;*
;* **********************************
;*                                   *
;* HLC Games - Software Entertainment *
;*                                     *
;* (c) Copyright 2003 - Lukas Hermanns  *
;*                                       *
;* ****************************************
;*  ___    ___    ___          _____
;* /\  \  /\  \  /\  \        /  ___\
;* \ \  \_\_\  \ \ \  \      /\  \__/
;*  \ \   ___   \ \ \  \     \ \  \
;*   \ \  \__/\  \ \ \  \____ \ \  \___
;*    \ \__\ \ \__\ \ \______\ \ \_____\
;*     \/__/  \/__/  \/______/  \/_____/
;*
;* ****************************************
;*
;* ********************** HLC SoftPixelEngine - (03/01/2008) ************************
;*
;* (c) Copyright 2008 - Lukas Hermanns
;*
;* SoftPixel Engine Wrapper for BlitzBasic
;* Auto generated code from 20:09:51 30/08/2011
;*

Function Graphics3D(Width%, Height%, Depth% = 32, Mode% = 0, HideBBRuntimeWindow = True) ; Special case
    If HideBBRuntimeWindow And SystemProperty("APPHWND") <> ""
        extHideWindow(Int(SystemProperty("APPHWND")))
    EndIf
    spwGraphics3D(Width%, Height%, Depth%, Mode%)
End Function

Function Graphics(Width%, Height%, Depth% = 32, Mode% = 0)
    spwGraphics(Width%, Height%, Depth%, Mode%)
End Function

Function EndGraphics()
    spwEndGraphics()
End Function

Function AppTitle(Title$, EndMessage$ = "")
    spwAppTitle(Title$, EndMessage$)
End Function

Function GraphicsWidth%()
    Return spwGraphicsWidth%()
End Function

Function GraphicsHeight%()
    Return spwGraphicsHeight%()
End Function

Function GraphicsDepth%()
    Return spwGraphicsDepth%()
End Function

Function MessageBox(Message$, ObjType% = 0)
    spwMessageBox(Message$, ObjType%)
End Function

Function GetKey%()
    Return spwGetKey%()
End Function

Function WaitKey()
    spwWaitKey()
End Function

Function KeyDown%(Scancode%)
    Return spwKeyDown%(Scancode%)
End Function

Function KeyHit%(Scancode%)
    Return spwKeyHit%(Scancode%)
End Function

Function GetMouse%()
    Return spwGetMouse%()
End Function

Function MouseDown%(Scancode%)
    Return spwMouseDown%(Scancode%)
End Function

Function MouseHit%(Scancode%)
    Return spwMouseHit%(Scancode%)
End Function

Function MouseX%()
    Return spwMouseX%()
End Function

Function MouseY%()
    Return spwMouseY%()
End Function

Function MouseZ%()
    Return spwMouseZ%()
End Function

Function MouseXSpeed%()
    Return spwMouseXSpeed%()
End Function

Function MouseYSpeed%()
    Return spwMouseYSpeed%()
End Function

Function MouseZSpeed%()
    Return spwMouseZSpeed%()
End Function

Function ShowPointer()
    spwShowPointer()
End Function

Function HidePointer()
    spwHidePointer()
End Function

Function MoveMouse(X%, Y%)
    spwMoveMouse(X%, Y%)
End Function

Function WaitMouse()
    spwWaitMouse()
End Function

Function MouseWait()
    spwMouseWait()
End Function

Function CreateListener%(Parent%, RollOff# = 1.0, DopplerScale# = 1.0, DistanceScale# = 1.0)
    Return spwCreateListener%(Parent%, RollOff#, DopplerScale#, DistanceScale#)
End Function

Function LoadSound%(File$)
    Return spwLoadSound%(File$)
End Function

Function Load3DSound%(File$)
    Return spwLoad3DSound%(File$)
End Function

Function FreeSound(Sound%)
    spwFreeSound(Sound%)
End Function

Function LoopSound(Sound%)
    spwLoopSound(Sound%)
End Function

Function PlaySound(Sound%)
    spwPlaySound(Sound%)
End Function

Function SoundPitch(Sound%, Frequency%)
    spwSoundPitch(Sound%, Frequency%)
End Function

Function SoundPan(Sound%, Balance#)
    spwSoundPan(Sound%, Balance#)
End Function

Function SoundVolume(Sound%, Volume#)
    spwSoundVolume(Sound%, Volume#)
End Function

Function EmitSound(Sound%, Entity%)
    spwEmitSound(Sound%, Entity%)
End Function

Function MoveCameraFree(Camera% = 0, MoveSpeed# = 0.25, TurnSpeed# = 0.25, MaxTurnDegree# = 90.0, UseArrowKeys% = True)
    spwMoveCameraFree(Camera%, MoveSpeed#, TurnSpeed#, MaxTurnDegree#, UseArrowKeys%)
End Function

Function CombineModels(MeshA%, MeshB%, Mode% = 0, Precision# = 0.00001)
    spwCombineModels(MeshA%, MeshB%, Mode%, Precision#)
End Function

Function LoadScriptFile%(File$)
    Return spwLoadScriptFile%(File$)
End Function

Function CreateCamera%(Parent% = 0)
    Return spwCreateCamera%(Parent%)
End Function

Function CreateLight%(ObjType% = 1, Parent% = 0)
    Return spwCreateLight%(ObjType%, Parent%)
End Function

Function CopyEntity%(Entity%, Parent% = 0)
    Return spwCopyEntity%(Entity%, Parent%)
End Function

Function CreatePivot%(Parent% = 0)
    Return spwCreatePivot%(Parent%)
End Function

Function CreateMesh%(Parent% = 0)
    Return spwCreateMesh%(Parent%)
End Function

Function CreateCube%(Parent% = 0)
    Return spwCreateCube%(Parent%)
End Function

Function CreateCone%(Segments% = 8, Solid% = True, Parent% = 0)
    Return spwCreateCone%(Segments%, Solid%, Parent%)
End Function

Function CreateCylinder%(Segments% = 8, Solid% = True, Parent% = 0)
    Return spwCreateCylinder%(Segments%, Solid%, Parent%)
End Function

Function CreatePipe%(Segments% = 8, OuterRadius# = 1.0, InnerRadius# = 0.5, Parent% = 0)
    Return spwCreatePipe%(Segments%, OuterRadius#, InnerRadius#, Parent%)
End Function

Function CreateSphere%(Segments% = 8, Parent% = 0)
    Return spwCreateSphere%(Segments%, Parent%)
End Function

Function CreateIcoSphere%(Segments% = 3, Parent% = 0)
    Return spwCreateIcoSphere%(Segments%, Parent%)
End Function

Function CreateTorus%(Segments% = 8, OuterRadius# = 1.0, InnerRadius# = 0.5, Parent% = 0)
    Return spwCreateTorus%(Segments%, OuterRadius#, InnerRadius#, Parent%)
End Function

Function CreateSpiral%(Segments% = 8, OuterRadius# = 1.0, InnerRadius# = 0.5, DegreeLength# = 360.0, DegreeHeight# = 2.0, Solid% = True, Parent% = 0)
    Return spwCreateSpiral%(Segments%, OuterRadius#, InnerRadius#, DegreeLength#, DegreeHeight#, Solid%, Parent%)
End Function

Function CreatePlane%(Segments% = 1, Parent% = 0, Radius# = 1000.0)
    Return spwCreatePlane%(Segments%, Parent%, Radius#)
End Function

Function CreateTetrahedron%(Parent% = 0)
    Return spwCreateTetrahedron%(Parent%)
End Function

Function CreateDodecahedron%(Parent% = 0)
    Return spwCreateDodecahedron%(Parent%)
End Function

Function CreateIcosahedron%(Parent% = 0)
    Return spwCreateIcosahedron%(Parent%)
End Function

Function CreateCuboctahedron%(Parent% = 0)
    Return spwCreateCuboctahedron%(Parent%)
End Function

Function CreateOctahedron%(Parent% = 0)
    Return spwCreateOctahedron%(Parent%)
End Function

Function CreateTeapot%(Parent% = 0)
    Return spwCreateTeapot%(Parent%)
End Function

Function CreateSkyBox%(TexBack%, TexFront%, TexTop%, TexBottom%, TexLeft%, TexRight%, Radius# = 100.0)
    Return spwCreateSkyBox%(TexBack%, TexFront%, TexTop%, TexBottom%, TexLeft%, TexRight%, Radius#)
End Function

Function LoadHeightField%(File$, Segments% = -1, Parent% = 0)
    Return spwLoadHeightField%(File$, Segments%, Parent%)
End Function

Function LoadTerrain%(File$, Parent% = 0)
    Return spwLoadTerrain%(File$, Parent%)
End Function

Function LoadMesh%(File$, Parent% = 0)
    Return spwLoadMesh%(File$, Parent%)
End Function

Function LoadAnimMesh%(File$, Parent% = 0)
    Return spwLoadAnimMesh%(File$, Parent%)
End Function

Function LoadMD2%(File$, Parent% = 0)
    Return spwLoadMD2%(File$, Parent%)
End Function

Function LoadBSP%(File$, Gamma# = 0.0, Parent% = 0)
    Return spwLoadBSP%(File$, Gamma#, Parent%)
End Function

Function BSPLighting(BSP%, UseLightmaps%)
    spwBSPLighting(BSP%, UseLightmaps%)
End Function

Function LoadSprite%(File$, Flags% = 9, Parent% = 0)
    Return spwLoadSprite%(File$, Flags%, Parent%)
End Function

Function CreateSprite%(Parent% = 0)
    Return spwCreateSprite%(Parent%)
End Function

Function RotateSprite(Sprite%, Angle#)
    spwRotateSprite(Sprite%, Angle#)
End Function

Function ScaleSprite(Sprite%, Width#, Height#)
    spwScaleSprite(Sprite%, Width#, Height#)
End Function

Function HandleSprite(Sprite%, X#, Y#)
    spwHandleSprite(Sprite%, X#, Y#)
End Function

Function SpriteViewMode(Sprite%, Mode%)
    spwSpriteViewMode(Sprite%, Mode%)
End Function

Function MeshReference(Mesh%, MeshReference%, CopyLocation% = False, CopyMaterial% = False)
    spwMeshReference(Mesh%, MeshReference%, CopyLocation%, CopyMaterial%)
End Function

Function SurfaceReference(Surface%, SurfaceReference%, CopyTextures% = False)
    spwSurfaceReference(Surface%, SurfaceReference%, CopyTextures%)
End Function

Function AnimateMD2(Entity%, Mode% = 1, Speed# = 1.0, FirstFrame% = 0, LastFrame% = 0, Transition# = 0.0)
    spwAnimateMD2(Entity%, Mode%, Speed#, FirstFrame%, LastFrame%, Transition#)
End Function

Function Animate(Entity%, Mode% = 1, Speed# = 1.0, Sequence% = 0, Transition# = 0.0)
    spwAnimate(Entity%, Mode%, Speed#, Sequence%, Transition#)
End Function

Function Animating%(Entity%)
    Return spwAnimating%(Entity%)
End Function

Function AnimLength%(Entity%)
    Return spwAnimLength%(Entity%)
End Function

Function AnimSeq%(Entity%)
    Return spwAnimSeq%(Entity%)
End Function

Function AnimTime#(Entity%)
    Return spwAnimTime#(Entity%)
End Function

Function SetAnimKey(Entity%, Frame%, PosKey% = True, RotKey% = True, SclKey% = True)
    spwSetAnimKey(Entity%, Frame%, PosKey%, RotKey%, SclKey%)
End Function

Function AddAnimSeq(Entity%, Length%)
    spwAddAnimSeq(Entity%, Length%)
End Function

Function AnimSpline(Entity%, Enable%, Expansion# = 1.0)
    spwAnimSpline(Entity%, Enable%, Expansion#)
End Function

Function ExtractAnimSeq%(Entity%, FirstFrame%, LastFrame%, Sequence% = 0)
    Return spwExtractAnimSeq%(Entity%, FirstFrame%, LastFrame%, Sequence%)
End Function

Function EntityParent(Entity%, Parent%, isGlobal% = True)
    spwEntityParent(Entity%, Parent%, isGlobal%)
End Function

Function GetParent%(Entity%)
    Return spwGetParent%(Entity%)
End Function

Function CountChildren%(Entity%)
    Return spwCountChildren%(Entity%)
End Function

Function GetChild%(Entity%, Index%)
    Return spwGetChild%(Entity%, Index%)
End Function

Function ShowEntity(Entity%)
    spwShowEntity(Entity%)
End Function

Function HideEntity(Entity%)
    spwHideEntity(Entity%)
End Function

Function FreeEntity(Entity%)
    spwFreeEntity(Entity%)
End Function

Function PositionEntity(Entity%, X#, Y#, Z#, isGlobal% = False)
    spwPositionEntity(Entity%, X#, Y#, Z#, isGlobal%)
End Function

Function MoveEntity(Entity%, X#, Y#, Z#)
    spwMoveEntity(Entity%, X#, Y#, Z#)
End Function

Function TranslateEntity(Entity%, X#, Y#, Z#, isGlobal% = False)
    spwTranslateEntity(Entity%, X#, Y#, Z#, isGlobal%)
End Function

Function RotateEntity(Entity%, X#, Y#, Z#, isGlobal% = False)
    spwRotateEntity(Entity%, X#, Y#, Z#, isGlobal%)
End Function

Function TurnEntity(Entity%, X#, Y#, Z#, isGlobal% = False)
    spwTurnEntity(Entity%, X#, Y#, Z#, isGlobal%)
End Function

Function ScaleEntity(Entity%, X#, Y#, Z#, isGlobal% = False)
    spwScaleEntity(Entity%, X#, Y#, Z#, isGlobal%)
End Function

Function PointEntity(Entity%, Target%, Roll# = 0.0)
    spwPointEntity(Entity%, Target%, Roll#)
End Function

Function RotateEntityQuat(Entity%, X#, Y#, Z#, W#, isGlobal% = False)
    spwRotateEntityQuat(Entity%, X#, Y#, Z#, W#, isGlobal%)
End Function

Function ScaleMesh(Mesh%, X#, Y#, Z#)
    spwScaleMesh(Mesh%, X#, Y#, Z#)
End Function

Function FlipMesh(Mesh%)
    spwFlipMesh(Mesh%)
End Function

Function FitMesh(Mesh%, X#, Y#, Z#, Width#, Height#, Depth#, Uniform% = False)
    spwFitMesh(Mesh%, X#, Y#, Z#, Width#, Height#, Depth#, Uniform%)
End Function

Function RotateMesh(Mesh%, X#, Y#, Z#)
    spwRotateMesh(Mesh%, X#, Y#, Z#)
End Function

Function PositionMesh(Mesh%, X#, Y#, Z#)
    spwPositionMesh(Mesh%, X#, Y#, Z#)
End Function

Function UpdateNormals(Mesh%)
    spwUpdateNormals(Mesh%)
End Function

Function CreateSurface%(Mesh%, Brush% = 0)
    Return spwCreateSurface%(Mesh%, Brush%)
End Function

Function ClearSurface(Surface%, ClearVertices% = True, ClearTriangles% = True)
    spwClearSurface(Surface%, ClearVertices%, ClearTriangles%)
End Function

Function GetSurface%(Mesh%, Index%)
    Return spwGetSurface%(Mesh%, Index%)
End Function

Function FindSurface%(Mesh%, Brush%)
    Return spwFindSurface%(Mesh%, Brush%)
End Function

Function AddVertex%(Surface%, X#, Y#, Z#, U# = 0.0, V# = 0.0, W# = 0.0)
    Return spwAddVertex%(Surface%, X#, Y#, Z#, U#, V#, W#)
End Function

Function AddTriangle%(Surface%, v0%, v1%, v2%)
    Return spwAddTriangle%(Surface%, v0%, v1%, v2%)
End Function

Function AddBezierPatch(Surface%, Segments% = 10)
    spwAddBezierPatch(Surface%, Segments%)
End Function

Function CountSurfaces%(Mesh%)
    Return spwCountSurfaces%(Mesh%)
End Function

Function CountVertices%(Surface%)
    Return spwCountVertices%(Surface%)
End Function

Function CountTriangles%(Surface%)
    Return spwCountTriangles%(Surface%)
End Function

Function VertexCoords(Surface%, Index%, X#, Y#, Z#)
    spwVertexCoords(Surface%, Index%, X#, Y#, Z#)
End Function

Function VertexNormal(Surface%, Index%, X#, Y#, Z#)
    spwVertexNormal(Surface%, Index%, X#, Y#, Z#)
End Function

Function VertexBinormal(Surface%, Index%, X#, Y#, Z#)
    spwVertexBinormal(Surface%, Index%, X#, Y#, Z#)
End Function

Function VertexTangent(Surface%, Index%, X#, Y#, Z#)
    spwVertexTangent(Surface%, Index%, X#, Y#, Z#)
End Function

Function VertexColor(Surface%, Index%, Red%, Green%, Blue%, Alpha# = 1.0)
    spwVertexColor(Surface%, Index%, Red%, Green%, Blue%, Alpha#)
End Function

Function VertexTexCoords(Surface%, Index%, U#, V#, W# = 0.0, Layer% = 0)
    spwVertexTexCoords(Surface%, Index%, U#, V#, W#, Layer%)
End Function

Function UpdateMeshBuffer(Mesh%, Surface% = 0)
    spwUpdateMeshBuffer(Mesh%, Surface%)
End Function

Function VertexX#(Surface%, Index%)
    Return spwVertexX#(Surface%, Index%)
End Function

Function VertexY#(Surface%, Index%)
    Return spwVertexY#(Surface%, Index%)
End Function

Function VertexZ#(Surface%, Index%)
    Return spwVertexZ#(Surface%, Index%)
End Function

Function VertexNX#(Surface%, Index%)
    Return spwVertexNX#(Surface%, Index%)
End Function

Function VertexNY#(Surface%, Index%)
    Return spwVertexNY#(Surface%, Index%)
End Function

Function VertexNZ#(Surface%, Index%)
    Return spwVertexNZ#(Surface%, Index%)
End Function

Function VertexBX#(Surface%, Index%)
    Return spwVertexBX#(Surface%, Index%)
End Function

Function VertexBY#(Surface%, Index%)
    Return spwVertexBY#(Surface%, Index%)
End Function

Function VertexBZ#(Surface%, Index%)
    Return spwVertexBZ#(Surface%, Index%)
End Function

Function VertexTX#(Surface%, Index%)
    Return spwVertexTX#(Surface%, Index%)
End Function

Function VertexTY#(Surface%, Index%)
    Return spwVertexTY#(Surface%, Index%)
End Function

Function VertexTZ#(Surface%, Index%)
    Return spwVertexTZ#(Surface%, Index%)
End Function

Function VertexRed%(Surface%, Index%)
    Return spwVertexRed%(Surface%, Index%)
End Function

Function VertexGreen%(Surface%, Index%)
    Return spwVertexGreen%(Surface%, Index%)
End Function

Function VertexBlue%(Surface%, Index%)
    Return spwVertexBlue%(Surface%, Index%)
End Function

Function VertexAlpha#(Surface%, Index%)
    Return spwVertexAlpha#(Surface%, Index%)
End Function

Function VertexU#(Surface%, Index%)
    Return spwVertexU#(Surface%, Index%)
End Function

Function VertexV#(Surface%, Index%)
    Return spwVertexV#(Surface%, Index%)
End Function

Function VertexW#(Surface%, Index%)
    Return spwVertexW#(Surface%, Index%)
End Function

Function TriangleVertex%(Surface%, Index%, Corner%)
    Return spwTriangleVertex%(Surface%, Index%, Corner%)
End Function

Function EntityColor(Entity%, Red%, Green%, Blue%)
    spwEntityColor(Entity%, Red%, Green%, Blue%)
End Function

Function EntityAlpha(Entity%, Alpha#)
    spwEntityAlpha(Entity%, Alpha#)
End Function

Function EntityShininess(Entity%, Shininess#)
    spwEntityShininess(Entity%, Shininess#)
End Function

Function EntityFX(Entity%, Mode%)
    spwEntityFX(Entity%, Mode%)
End Function

Function EntityBlend(Entity%, Mode%)
    spwEntityBlend(Entity%, Mode%)
End Function

Function EntityOrder(Entity%, Order%)
    spwEntityOrder(Entity%, Order%)
End Function

Function EntityX#(Entity%, isGlobal% = False)
    Return spwEntityX#(Entity%, isGlobal%)
End Function

Function EntityY#(Entity%, isGlobal% = False)
    Return spwEntityY#(Entity%, isGlobal%)
End Function

Function EntityZ#(Entity%, isGlobal% = False)
    Return spwEntityZ#(Entity%, isGlobal%)
End Function

Function EntityPitch#(Entity%, isGlobal% = False)
    Return spwEntityPitch#(Entity%, isGlobal%)
End Function

Function EntityYaw#(Entity%, isGlobal% = False)
    Return spwEntityYaw#(Entity%, isGlobal%)
End Function

Function EntityRoll#(Entity%, isGlobal% = False)
    Return spwEntityRoll#(Entity%, isGlobal%)
End Function

Function EntityMatrix(Entity%, MatrixOut%, isGlobal% = True)
    spwEntityMatrix(Entity%, MatrixOut%, isGlobal%)
End Function

Function MeshWidth#(Mesh%)
    Return spwMeshWidth#(Mesh%)
End Function

Function MeshHeight#(Mesh%)
    Return spwMeshHeight#(Mesh%)
End Function

Function MeshDepth#(Mesh%)
    Return spwMeshDepth#(Mesh%)
End Function

Function EntityName$(Entity%)
    Return spwEntityName$(Entity%)
End Function

Function NameEntity(Entity%, Name$)
    spwNameEntity(Entity%, Name$)
End Function

Function EntityDistance#(SrcEntity%, DestEntity%)
    Return spwEntityDistance#(SrcEntity%, DestEntity%)
End Function

Function CameraViewport(Camera%, X%, Y%, Width%, Height%)
    spwCameraViewport(Camera%, X%, Y%, Width%, Height%)
End Function

Function CameraRange(Camera%, Near#, Far#)
    spwCameraRange(Camera%, Near#, Far#)
End Function

Function CameraZoom(Camera%, Zoom#)
    spwCameraZoom(Camera%, Zoom#)
End Function

Function CameraProjMode(Camera%, Mode%)
    spwCameraProjMode(Camera%, Mode%)
End Function

Function LightColor(Light%, Red%, Green%, Blue%)
    spwLightColor(Light%, Red%, Green%, Blue%)
End Function

Function LightRange(Light%, Range#)
    spwLightRange(Light%, Range#)
End Function

Function LightConeAngles(Light%, InnerAngle#, OuterAngle#)
    spwLightConeAngles(Light%, InnerAngle#, OuterAngle#)
End Function

Function AmbientLight(Red%, Green%, Blue%)
    spwAmbientLight(Red%, Green%, Blue%)
End Function

Function CaptureWorld()
    spwCaptureWorld()
End Function

Function RenderWorld(Tween# = 1.0)
    spwRenderWorld(Tween#)
End Function

Function RenderWorldStereo(Camera%, CamDegree#, CamDist# = 0.25)
    spwRenderWorldStereo(Camera%, CamDegree#, CamDist#)
End Function

Function UpdateWorld()
    spwUpdateWorld()
End Function

Function WireFrame(Mode%)
    spwWireFrame(Mode%)
End Function

Function EntityType(Entity%, CollisionType%, Recursive% = False)
    spwEntityType(Entity%, CollisionType%, Recursive%)
End Function

Function EntityRadius(Entity%, RadiusX#, RadiusY# = -1.0)
    spwEntityRadius(Entity%, RadiusX#, RadiusY#)
End Function

Function ResetEntity(Entity%)
    spwResetEntity(Entity%)
End Function

Function Collisions(SrcType%, DestType%, Method%, Response%)
    spwCollisions(SrcType%, DestType%, Method%, Response%)
End Function

Function CountCollisions%(Entity%)
    Return spwCountCollisions%(Entity%)
End Function

Function CollisionEntity%(Entity%, Index%)
    Return spwCollisionEntity%(Entity%, Index%)
End Function

Function CollisionSurface%(Entity%, Index%)
    Return spwCollisionSurface%(Entity%, Index%)
End Function

Function CollisionTriangle%(Entity%, Index%)
    Return spwCollisionTriangle%(Entity%, Index%)
End Function

Function CollisionX#(Entity%, Index%)
    Return spwCollisionX#(Entity%, Index%)
End Function

Function CollisionY#(Entity%, Index%)
    Return spwCollisionY#(Entity%, Index%)
End Function

Function CollisionZ#(Entity%, Index%)
    Return spwCollisionZ#(Entity%, Index%)
End Function

Function CollisionNX#(Entity%, Index%)
    Return spwCollisionNX#(Entity%, Index%)
End Function

Function CollisionNY#(Entity%, Index%)
    Return spwCollisionNY#(Entity%, Index%)
End Function

Function CollisionNZ#(Entity%, Index%)
    Return spwCollisionNZ#(Entity%, Index%)
End Function

Function EntityCollided%(Entity%, ObjType%)
    Return spwEntityCollided%(Entity%, ObjType%)
End Function

Function MeshesIntersect%(MeshA%, MeshB%)
    Return spwMeshesIntersect%(MeshA%, MeshB%)
End Function

Function EntityPickMode(Entity%, Geometry% = 0, Obscurer% = True)
    spwEntityPickMode(Entity%, Geometry%, Obscurer%)
End Function

Function CameraPick%(Camera%, X%, Y%, PickLength# = -1.0)
    Return spwCameraPick%(Camera%, X%, Y%, PickLength#)
End Function

Function LinePick%(X#, Y#, Z#, DX#, DY#, DZ#, Radius# = 0.0)
    Return spwLinePick%(X#, Y#, Z#, DX#, DY#, DZ#, Radius#)
End Function

Function EntityPick%(Entity%, Range#)
    Return spwEntityPick%(Entity%, Range#)
End Function

Function PickedEntity%()
    Return spwPickedEntity%()
End Function

Function PickedSurface%()
    Return spwPickedSurface%()
End Function

Function PickedTriangle%()
    Return spwPickedTriangle%()
End Function

Function PickedX#()
    Return spwPickedX#()
End Function

Function PickedY#()
    Return spwPickedY#()
End Function

Function PickedZ#()
    Return spwPickedZ#()
End Function

Function PickedNX#()
    Return spwPickedNX#()
End Function

Function PickedNY#()
    Return spwPickedNY#()
End Function

Function PickedNZ#()
    Return spwPickedNZ#()
End Function

Function PickedTime#()
    Return spwPickedTime#()
End Function

Function CameraProject(Camera%, X#, Y#, Z#)
    spwCameraProject(Camera%, X#, Y#, Z#)
End Function

Function ProjectedX%()
    Return spwProjectedX%()
End Function

Function ProjectedY%()
    Return spwProjectedY%()
End Function

Function ProjectedZ%()
    Return spwProjectedZ%()
End Function

Function EntityBoundBox(Entity%, X#, Y#, Z#, Width#, Height#, Depth#, Enable% = True)
    spwEntityBoundBox(Entity%, X#, Y#, Z#, Width#, Height#, Depth#, Enable%)
End Function

Function EntityBoundSphere(Entity%, Radius#, Enable% = True)
    spwEntityBoundSphere(Entity%, Radius#, Enable%)
End Function

Function MeshBoundBox(Mesh%, Enable% = True)
    spwMeshBoundBox(Mesh%, Enable%)
End Function

Function UpdateSimulation(StepTime# = 0.017)
    spwUpdateSimulation(StepTime#)
End Function

Function CreateRigidBodyNode%(RootNode%, ObjType%, X# = 0.5, Y# = 0.5, Z# = 0.5, Radius# = 0.5, Height# = 0.5, Mass# = 25.0)
    Return spwCreateRigidBodyNode%(RootNode%, ObjType%, X#, Y#, Z#, Radius#, Height#, Mass#)
End Function

Function CreateRigidBodyMesh%(MeshGeom%, Mass# = 25.0)
    Return spwCreateRigidBodyMesh%(MeshGeom%, Mass#)
End Function

Function AddRigidBodyJoint%(Object%, Child%, ObjType%, PointX#, PointY#, PointZ#, DirX# = 0.0, DirY# = 1.0, DirZ# = 0.0, Dir2X# = 0.0, Dir2Y# = 1.0, Dir2Z# = 0.0)
    Return spwAddRigidBodyJoint%(Object%, Child%, ObjType%, PointX#, PointY#, PointZ#, DirX#, DirY#, DirZ#, Dir2X#, Dir2Y#, Dir2Z#)
End Function

Function Flip(Vsync% = False) ; Special case
    If Not spwFlip%(Vsync) Then
        spwEndGraphics()
        End
    EndIf
End Function

Function Color(Red%, Green%, Blue%, Alpha% = 255)
    spwColor(Red%, Green%, Blue%, Alpha%)
End Function

Function GetColor(X%, Y%)
    spwGetColor(X%, Y%)
End Function

Function ColorRed%()
    Return spwColorRed%()
End Function

Function ColorGreen%()
    Return spwColorGreen%()
End Function

Function ColorBlue%()
    Return spwColorBlue%()
End Function

Function MultiColor(Index%, Red%, Green%, Blue%, Alpha# = 1.0)
    spwMultiColor(Index%, Red%, Green%, Blue%, Alpha#)
End Function

Function WritePixelFast(X%, Y%, Color%, Buffer% = 0)
    spwWritePixelFast(X%, Y%, Color%, Buffer%)
End Function

Function WritePixel(X%, Y%, Color%, Buffer% = 0)
    spwWritePixel(X%, Y%, Color%, Buffer%)
End Function

Function ReadPixelFast%(X%, Y%, Buffer% = 0)
    Return spwReadPixelFast%(X%, Y%, Buffer%)
End Function

Function ReadPixel%(X%, Y%, Buffer% = 0)
    Return spwReadPixel%(X%, Y%, Buffer%)
End Function

Function CopyPixelFast(SrcX%, SrcY%, SrcBuffer%, DestX%, DestY%, DestBuffer% = 0)
    spwCopyPixelFast(SrcX%, SrcY%, SrcBuffer%, DestX%, DestY%, DestBuffer%)
End Function

Function CopyPixel(SrcX%, SrcY%, SrcBuffer%, DestX%, DestY%, DestBuffer% = 0)
    spwCopyPixel(SrcX%, SrcY%, SrcBuffer%, DestX%, DestY%, DestBuffer%)
End Function

Function CopyRect(SrcX%, SrcY%, SrcWidth%, SrcHeight%, DestX%, DestY%, SrcBuffer% = 0, DestBuffer% = 0)
    spwCopyRect(SrcX%, SrcY%, SrcWidth%, SrcHeight%, DestX%, DestY%, SrcBuffer%, DestBuffer%)
End Function

Function Plot(X%, Y%)
    spwPlot(X%, Y%)
End Function

Function Line(X1%, Y1%, X2%, Y2%)
    spwLine(X1%, Y1%, X2%, Y2%)
End Function

Function Rect(X%, Y%, Width%, Height%, Solid% = True)
    spwRect(X%, Y%, Width%, Height%, Solid%)
End Function

Function Oval(X%, Y%, Width%, Height%, Solid% = True)
    spwOval(X%, Y%, Width%, Height%, Solid%)
End Function

Function CreateTexture%(Width%, Height%, Flags% = 9, Frames% = 0)
    Return spwCreateTexture%(Width%, Height%, Flags%, Frames%)
End Function

Function LoadTexture%(File$, Flags% = 9)
    Return spwLoadTexture%(File$, Flags%)
End Function

Function LoadAnimTexture%(File$, Flags%, FrameWidth%, FrameHeight%, FirstFrame%, FrameCount%)
    Return spwLoadAnimTexture%(File$, Flags%, FrameWidth%, FrameHeight%, FirstFrame%, FrameCount%)
End Function

Function FreeTexture(Texture%)
    spwFreeTexture(Texture%)
End Function

Function ScaleTexture(Texture%, Width#, Height#)
    spwScaleTexture(Texture%, Width#, Height#)
End Function

Function PositionTexture(Texture%, X#, Y#)
    spwPositionTexture(Texture%, X#, Y#)
End Function

Function RotateTexture(Texture%, Angle#)
    spwRotateTexture(Texture%, Angle#)
End Function

Function TextureBlend(Texture%, Mode%)
    spwTextureBlend(Texture%, Mode%)
End Function

Function TextureCoords(Texture%, Coords%)
    spwTextureCoords(Texture%, Coords%)
End Function

Function EntityTexture(Entity%, Texture%, Frame% = 0, Index% = 0)
    spwEntityTexture(Entity%, Texture%, Frame%, Index%)
End Function

Function PaintEntity(Entity%, Brush%)
    spwPaintEntity(Entity%, Brush%)
End Function

Function PaintSurface(Surface%, Brush%)
    spwPaintSurface(Surface%, Brush%)
End Function

Function CreateBrush%(Red% = 0, Green% = 0, Blue% = 0)
    Return spwCreateBrush%(Red%, Green%, Blue%)
End Function

Function LoadBrush%(File$, Flags% = 9, Width# = 1.0, Height# = 1.0)
    Return spwLoadBrush%(File$, Flags%, Width#, Height#)
End Function

Function FreeBrush(Brush%)
    spwFreeBrush(Brush%)
End Function

Function BrushTexture(Brush%, Texture%, Frame% = 0, Index% = 0)
    spwBrushTexture(Brush%, Texture%, Frame%, Index%)
End Function

Function PaintMesh(Mesh%, Brush%)
    spwPaintMesh(Mesh%, Brush%)
End Function

Function BrushShininess(Brush%, Shininess#)
    spwBrushShininess(Brush%, Shininess#)
End Function

Function MidHandle(ObjHandle%, Enable% = True)
    spwMidHandle(ObjHandle%, Enable%)
End Function

Function LoadImage%(File$)
    Return spwLoadImage%(File$)
End Function

Function LoadAnimImage%(File$, FrameWidth%, FrameHeight%, FirstFrame%, FrameCount%, Flags% = 9)
    Return spwLoadAnimImage%(File$, FrameWidth%, FrameHeight%, FirstFrame%, FrameCount%, Flags%)
End Function

Function CreateImage%(Width%, Height%, Frames% = 0)
    Return spwCreateImage%(Width%, Height%, Frames%)
End Function

Function CopyImage%(ObjHandle%)
    Return spwCopyImage%(ObjHandle%)
End Function

Function ImageWidth%(ObjHandle%)
    Return spwImageWidth%(ObjHandle%)
End Function

Function ImageHeight%(ObjHandle%)
    Return spwImageHeight%(ObjHandle%)
End Function

Function MaskImage(ObjHandle%, Red%, Green%, Blue%, Alpha% = 0)
    spwMaskImage(ObjHandle%, Red%, Green%, Blue%, Alpha%)
End Function

Function ScaleImage(ObjHandle%, Width#, Height#)
    spwScaleImage(ObjHandle%, Width#, Height#)
End Function

Function ResizeImage(ObjHandle%, Width%, Height%)
    spwResizeImage(ObjHandle%, Width%, Height%)
End Function

Function RotateImage(ObjHandle%, Angle#)
    spwRotateImage(ObjHandle%, Angle#)
End Function

Function AutoMidHandle(Enable%)
    spwAutoMidHandle(Enable%)
End Function

Function GrabImage(ObjHandle%, X%, Y%)
    spwGrabImage(ObjHandle%, X%, Y%)
End Function

Function TextureWidth%(ObjHandle%)
    Return spwTextureWidth%(ObjHandle%)
End Function

Function TextureHeight%(ObjHandle%)
    Return spwTextureHeight%(ObjHandle%)
End Function

Function DrawImage(ObjHandle%, X%, Y%, Frame% = 0)
    spwDrawImage(ObjHandle%, X%, Y%, Frame%)
End Function

Function DrawImageRect(ObjHandle%, X%, Y%, RectX%, RectY%, RectWidth%, RectHeight%, Frame% = 0)
    spwDrawImageRect(ObjHandle%, X%, Y%, RectX%, RectY%, RectWidth%, RectHeight%, Frame%)
End Function

Function DrawImageStretch(ObjHandle%, X%, Y%, Width%, Height%, MapX1# = 0.0, MapY1# = 0.0, MapX2# = 1.0, MapY2# = 1.0, Frame% = 0)
    spwDrawImageStretch(ObjHandle%, X%, Y%, Width%, Height%, MapX1#, MapY1#, MapX2#, MapY2#, Frame%)
End Function

Function DrawImageRotate(ObjHandle%, X%, Y%, Angle#, Radius#, Frame% = 0)
    spwDrawImageRotate(ObjHandle%, X%, Y%, Angle#, Radius#, Frame%)
End Function

Function TileImage(ObjHandle%, X%, Y%, Frame% = 0)
    spwTileImage(ObjHandle%, X%, Y%, Frame%)
End Function

Function DrawBlock(ObjHandle%, X%, Y%, Frame% = 0)
    spwDrawBlock(ObjHandle%, X%, Y%, Frame%)
End Function

Function Cls()
    spwCls()
End Function

Function ClsColor(Red%, Green%, Blue%, Alpha% = 255)
    spwClsColor(Red%, Green%, Blue%, Alpha%)
End Function

Function MaskColor(Red%, Green%, Blue%, Alpha% = True)
    spwMaskColor(Red%, Green%, Blue%, Alpha%)
End Function

Function CameraClsColor(Camera%, Red%, Green%, Blue%)
    spwCameraClsColor(Camera%, Red%, Green%, Blue%)
End Function

Function CameraClsMode(Camera%, ClsColor%, ClsZBuffer%)
    spwCameraClsMode(Camera%, ClsColor%, ClsZBuffer%)
End Function

Function CameraFogColor(Camera%, Red%, Green%, Blue%)
    spwCameraFogColor(Camera%, Red%, Green%, Blue%)
End Function

Function CameraFogMode(Camera%, Mode%)
    spwCameraFogMode(Camera%, Mode%)
End Function

Function CameraFogRange(Camera%, Near#, Far#, FallOff# = 0.1)
    spwCameraFogRange(Camera%, Near#, Far#, FallOff#)
End Function

Function HWMultiTex(Enable%)
    spwHWMultiTex(Enable%)
End Function

Function TextureBuffer%(Texture%, Frame% = 0)
    Return spwTextureBuffer%(Texture%, Frame%)
End Function

Function ImageBuffer%(Image%, Frame% = 0)
    Return spwImageBuffer%(Image%, Frame%)
End Function

Function FrontBuffer%()
    Return spwFrontBuffer%()
End Function

Function BackBuffer%()
    Return spwBackBuffer%()
End Function

Function SetBuffer(Buffer%)
    spwSetBuffer(Buffer%)
End Function

Function LoadFont%(FontName$, Height% = 0, Bold% = False, Italic% = False, Underlined% = False, StrikeOut% = False)
    Return spwLoadFont%(FontName$, Height%, Bold%, Italic%, Underlined%, StrikeOut%)
End Function

Function FreeFont(Font%)
    spwFreeFont(Font%)
End Function

Function SetFont(Font%)
    spwSetFont(Font%)
End Function

Function StringWidth%(TextString$)
    Return spwStringWidth%(TextString$)
End Function

Function StringHeight%(TextString$)
    Return spwStringHeight%(TextString$)
End Function

Function FontWidth%()
    Return spwFontWidth%()
End Function

Function FontHeight%()
    Return spwFontHeight%()
End Function

Function Text(X%, Y%, TextString$, CenterX% = False, CenterY% = False)
    spwText(X%, Y%, TextString$, CenterX%, CenterY%)
End Function

Function OpenMovie%(File$, Resolution% = 512, Play% = True)
    Return spwOpenMovie%(File$, Resolution%, Play%)
End Function

Function CloseMovie(Movie%)
    spwCloseMovie(Movie%)
End Function

Function DrawMovie(Movie%, X%, Y%, Width% = -1, Height% = -1)
    spwDrawMovie(Movie%, X%, Y%, Width%, Height%)
End Function

Function MovieWidth%(Movie%)
    Return spwMovieWidth%(Movie%)
End Function

Function MovieHeight%(Movie%)
    Return spwMovieHeight%(Movie%)
End Function

Function MoviePlaying%(Movie%)
    Return spwMoviePlaying%(Movie%)
End Function

Function MovieSound%(Movie%)
    Return spwMovieSound%(Movie%)
End Function

Function MipMapFilter(Mode%, Anisotropy% = 2)
    spwMipMapFilter(Mode%, Anisotropy%)
End Function



; ================================================================================
