; SPE Wrapper Demo3 - 25.3.2010

; This is the third demonstration of the "SoftPixel Engine Wrapper - v.2.x"
; Here you can see new 2D drawing features (texture and images are now the same!)

Include "SoftPixelEngineWrapper.bb"

OpenDebugLog(True, "DebugLog.txt")

Graphics(640, 480, 32, 0)

img = LoadImage("../media/SoftPixelEngineLogo.png")
MaskImage(img, 0, 0, 0, 255)

Angle# = 0.0
Radius# = 150.0

While Not KeyDown(1)
	
	Text(0, 0, "Third SPE Demo")
	
	; Enable multi color effect
	EnableMultiColor(True)
	
	; Set the multi color values
	; Parameters: { Ingdex [0 .. 3], Red, Green, Blue, Alpha# [0.0 .. 1.0] -> by default 1.0 }
	MultiColor(0, 255,   0,   0)
	MultiColor(1,   0, 255,   0)
	MultiColor(2,   0,   0, 255)
	MultiColor(3, 255, 255,   0)
	
	; Draw the rectangle now with several colors for each corner
	Rect(0, 0, GraphicsWidth(), GraphicsHeight())
	
	Angle = Angle + 1.0
	
	; Disable multi color effect
	EnableMultiColor(False)
	
	; Draw a streched image
	; Parameters: { img, x, y, width, height, map1x, map1y, map2x, map2y }
	DrawImageStretch(img, 0, GraphicsHeight()/2 - 150/2, GraphicsWidth(), 150, 0.0, 0.0, 4.0, 2.0)
	
	; Draw a rotating image
	DrawImageRotate(img, GraphicsWidth()/2, GraphicsHeight()/2, Angle, Radius)
	
	Flip
	
Wend

EndGraphics
End


; ====================