; SPE Wrapper Demo5 - 30.5.2010
; For bug report, please join our community at: "www.hlc-games.de/forum"

Include "SoftPixelEngineWrapper.bb"
Include "SoftPixelEngineWrapperConsts.bb"

OpenDebugLog(True, "spDebugLog.txt")

UseOpenGL()

Graphics3D(640, 480, 32, 0)

cam = CreateCamera()
PositionEntity(cam, 0, 0, -3)

obj = CreateCube()

tex = LoadTexture("../media/SoftPixelEngineLogo.png")
EntityTexture(obj, tex)

; Create the shader table to combine several shaders
ShaderTable = CreateShaderTable()

; Load the vertex- and pixel shader
VertexShader = LoadShader(ShaderTable, SHADER_VERTEX, GLSL_VERSION_1_20, "../media/ShaderTestVert.txt", "")
PixelShader = LoadShader(ShaderTable, SHADER_PIXEL, GLSL_VERSION_1_20, "../media/ShaderTestFrag.txt", "")

; Link (or rather combine) the shaders
ShaderTableLink(ShaderTable)

; Set the object's shader
SetShader(obj, ShaderTable)

While Not KeyDown(1)
	
	Deg# = Deg# + 0.25
	Factor# = Sin(Deg#)*0.015
	
	; Sets the pixel shader constant "Factor" to a new value
	SetShaderFloat(PixelShader, "Factor", Factor)
	
	TurnEntity(obj, 0, 0.1, 0)
	
	RenderWorld
	
	Flip
	
Wend

EndGraphics
End


; ====================